package com.example.demo.entrysData.service;

import java.util.List;
import java.util.Optional;

import org.springframework.stereotype.Service;

import com.example.demo.core.error.NotFoundException;
import com.example.demo.entrysData.model.EntrysDataEntity;
import com.example.demo.entrysData.repository.EntrysDataRepository;

@Service
public class EntrysDataService {
    private final EntrysDataRepository repository;

    public EntrysDataService(EntrysDataRepository repository) {
        this.repository = repository;
    }

    public List<EntrysDataEntity> getAll() {
        return repository.getAll();
    }

    public EntrysDataEntity get(Long id) {
        return Optional.ofNullable(repository.get(id))
                .orElseThrow(() -> new NotFoundException(id));
    }

    public EntrysDataEntity create(EntrysDataEntity entity) {
        return repository.create(entity);
    }

    public EntrysDataEntity update(Long id, EntrysDataEntity entity) {
        final EntrysDataEntity existsEntity = get(id);
        existsEntity.setLogin(entity.getLogin());
        existsEntity.setPassword(entity.getPassword());
        existsEntity.setDepartment(entity.getDepartment());
        return repository.update(existsEntity);
    }

    public EntrysDataEntity delete(Long id) {
        final EntrysDataEntity existsEntity = get(id);
        return repository.delete(existsEntity);
    }

    public Boolean AuthPassword(Long id, String pas) {
        final EntrysDataEntity existsEntity = get(id);
        String truePas = existsEntity.getPassword();
        if (truePas.equals(pas)) {
            return true;
        }
        return false;
    }

    public EntrysDataEntity updatePassword(Long id, String newPas, String oldPas) {
        final EntrysDataEntity existsEntity = get(id);
        String truePas = existsEntity.getPassword();
        if (truePas.equals(oldPas) && !oldPas.equals(newPas)) {
            existsEntity.setPassword(newPas);
        }
        return repository.update(existsEntity);
    }
}
